## net.sf.saxon.expr
Class ItemChecker

    java.lang.Object
      net.sf.saxon.expr.ComputedExpression
          net.sf.saxon.expr.UnaryExpression
              net.sf.saxon.expr.ItemChecker

All Implemented Interfaces:
  Container, Expression, InstructionInfoProvider, java.io.Serializable, javax.xml.transform.SourceLocator

public final class ItemChecker
extends UnaryExpression

A ItemChecker implements the item type checking of "treat as": that is, it returns the supplied sequence, checking that all its items are of the correct type

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.UnaryExpression
`operand`

Fields inherited from class net.sf.saxon.expr.ComputedExpression
`locationId, staticProperties`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`ItemChecker(Expression sequence, ItemType itemType, RoleLocator role)` Constructor

Method Summary
`protected java.lang.String` `displayOperator(NamePool pool)` Give a string representation of the operator for use in diagnostics
`boolean` `equals(java.lang.Object other)` Is this expression the same as another expression?
`Item` `evaluateItem(XPathContext context)` Evaluate as an Item.
`int` `getImplementationMethod()` An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process().
`ItemType` `getItemType(TypeHierarchy th)` Determine the data type of the items returned by the expression
`ItemType` `getRequiredType()` Get the required type
`SequenceIterator` `iterate(XPathContext context)` Iterate over the sequence of values
`void` `process(XPathContext context)` Process the instruction, without returning any tail calls
`Expression` `simplify(StaticContext env)` Simplify an expression
`Expression` `typeCheck(StaticContext env, ItemType contextItemType)` Type-check the expression

Methods inherited from class net.sf.saxon.expr.UnaryExpression
`computeCardinality, computeSpecialProperties, display, getBaseExpression, hashCode, iterateSubExpressions, optimize, promote`

Methods inherited from class net.sf.saxon.expr.ComputedExpression

`adoptChildExpression, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, dynamicError, dynamicError, effectiveBooleanValue, evaluateAsString, getCardinality, getColumnNumber, getConstructType, getDependencies, getExecutable, getInstructionInfo, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, markTailFunctionCalls, resetStaticProperties, setLocationId, setParentExpression, suppressValidation, typeError, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ItemChecker

    public ItemChecker(Expression sequence,
                       ItemType itemType,
                       RoleLocator role)

  Constructor

Method Detail

### getRequiredType

    public ItemType getRequiredType()

  Get the required type

### simplify

    public Expression simplify(StaticContext env)
                        throws XPathException

  Simplify an expression

  Specified by:
    `simplify` in interface `Expression`
  Overrides:
    `simplify` in class `UnaryExpression`
  Returns:
    the simplified expression
  Throws:
    `XPathException`

### typeCheck

    public Expression typeCheck(StaticContext env,
                                ItemType contextItemType)
                         throws XPathException

  Type-check the expression

  Specified by:
    `typeCheck` in interface `Expression`
  Overrides:
    `typeCheck` in class `UnaryExpression`
  Throws:
    `XPathException`

### getImplementationMethod

    public int getImplementationMethod()

  An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process(). This method indicates which of these methods is provided. This implementation provides both iterate() and process() methods natively.

  Specified by:
    `getImplementationMethod` in interface `Expression`
  Overrides:
    `getImplementationMethod` in class `ComputedExpression`

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Iterate over the sequence of values

  Specified by:
    `iterate` in interface `Expression`
  Overrides:
    `iterate` in class `ComputedExpression`
  Parameters:
    `context` - supplies the context for evaluation
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate as an Item.

  Specified by:
    `evaluateItem` in interface `Expression`
  Overrides:
    `evaluateItem` in class `ComputedExpression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### process

    public void process(XPathContext context)
                 throws XPathException

  Process the instruction, without returning any tail calls

  Specified by:
    `process` in interface `Expression`
  Overrides:
    `process` in class `ComputedExpression`
  Parameters:
    `context` - The dynamic context, giving access to the current node, the current variables, etc.
  Throws:
    `XPathException`

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Determine the data type of the items returned by the expression

  Specified by:
    `getItemType` in interface `Expression`
  Overrides:
    `getItemType` in class `UnaryExpression`
  Parameters:
    `th` -
  Returns:
    the item type of the items in the result sequence, insofar as this is known statically.

### equals

    public boolean equals(java.lang.Object other)

  Is this expression the same as another expression?

  Overrides:
    `equals` in class `UnaryExpression`

### displayOperator

    protected java.lang.String displayOperator(NamePool pool)

  Give a string representation of the operator for use in diagnostics

  Specified by:
    `displayOperator` in class `UnaryExpression`
  Returns:
    the operator, as a string